/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : Fri Jul 27 2001
    copyright            : (C) 2001 by Tom Weingarten
    email                : captaint@home.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <stdlib.h>
#include <stdio.h>
#include <iostream.h>
#include <vector.h>
#include <string>
#include "block.h"

void parseToBlocks();
block *parseToBlocksRecurse();
void clearWhiteSpace();
void clearWhiteSpace(block *current,bool TT,bool U);
bool isSpace(char test);
void clearRedundancy();
void clearRedundancy(block *current,qualities data);
void removeBlock(block *current);
void mergeBlocks(block *current);
void writeOutput();
void writeOutput(block *current);

block *blocks;
string strTotal;
int pos;
bool lastcharspace;

int main()
{
	//read in file from cin
	string strIn="";
	strTotal="";
	while(getline(cin,strIn))
	{
		strTotal += strIn + " ";
	}
	//parse file into blocks
	parseToBlocks();
	clearWhiteSpace();
	clearRedundancy();
	writeOutput();
}

void parseToBlocks()
{
	string strStore;
	blocks = new block();
	block *current = blocks;
	pos=0;
	if (strTotal[0] == '<')
	{
		strStore = "";
		do
		{
			pos++;
			strStore += strTotal[pos];
		}while (strTotal[pos] != '>');
		pos++;
		current->text = strStore;
		current->deep = parseToBlocksRecurse();
		if (current->deep != NULL)
			current->deep->last = current;
		current->next = parseToBlocksRecurse();
		if (current->next != NULL)
			current->next->last = current->next;
	}else
	{
		strStore = "";
		while (strTotal[pos] != '<')
		{
			strStore += strTotal[pos];
			pos++;
			if (pos == strTotal.length())
			{
				current->text = strStore;
				return;
			}
		}
		current->text = strStore;
		current->next = parseToBlocksRecurse();
		current->next->last = current;
	}
}

block *parseToBlocksRecurse()
{
	if (pos == strTotal.length())
		return NULL;
	string strStore="";
	block *current = new block();
	if (strTotal[pos] == '<')
	{
		strStore = "";
		do
		{
			pos++;
			strStore += strTotal[pos];
		}while (strTotal[pos] != '>');
		pos++;
		if (strStore[0] == '/')
		{
			return NULL;
		}else
		{
			current->text = strStore;
			current->deep = parseToBlocksRecurse();
			if (current->deep != NULL)
				current->deep->last = current;
			current->next = parseToBlocksRecurse();
			if (current->next != NULL)
				current->next->last = current;
		}
	}else
	{
		strStore = "";
		while (strTotal[pos] != '<')
		{
			strStore += strTotal[pos];
			pos++;
			if (pos == strTotal.length())
			{
				current->text = strStore;
				return current;
			}
		}
		current->text = strStore;
		current->next = parseToBlocksRecurse();
		if (current->next != NULL)
			current->next->last = current;
	}
	return current;
}

void clearWhiteSpace()
{
	lastcharspace = false;
	clearWhiteSpace(blocks,false,false);
}

void clearWhiteSpace(block *current,bool TT,bool U)
{
 	if (current == NULL)
 		return;
 	if (TT)
 	{
 		if (current->deep != NULL)
 		{
 			if (current->text == "PL>")
 			{
 				clearWhiteSpace(current->deep,false,U);
 			}
 		}
 		clearWhiteSpace(current->next,true,U);
 	}else
 	{
		if (current->isTag())
		{
			if (current->text == "TT>")
			{
				lastcharspace = false;
				clearWhiteSpace(current->deep,true,U);
			}else if (current->text == "U>")
			{
				clearWhiteSpace(current->deep,TT,true);
			}else if (current->isColorTag())
			{
				if (U)
				{
					lastcharspace = false;
					clearWhiteSpace(current->deep,TT,U);
					lastcharspace = false;
				}else
					clearWhiteSpace(current->deep,TT,U);
			}else	
				clearWhiteSpace(current->deep,TT,U);
		}else
		{
			string result="";
			int i;
			for (i=0;i<current->text.length();i++)
			{
				if (isSpace(current->text[i]))
				{
					if (!lastcharspace)
					{
						result += ' ';
						lastcharspace = true;
					}
				}else
				{
					result += current->text[i];
					lastcharspace = false;
				}
			}
			if (result == "")
			{
				if (current->last->deep == current)
				{
					current->last->deep = current->next;
					if (current->next != NULL)
						current->next->last = current->last;
				}else
				{
					current->last->next = current->next;
					if (current->next != NULL)
						current->next->last = current->last;
				}
			}else
				current->text = result;
		}
		clearWhiteSpace(current->next,TT,U);
	}
}

bool isSpace(char test)
{
	if (test == 0x20 ||
			test == 0x0D ||
			test == 0x0A ||
			test == 0x09)
			return true;
	else return false;
}

void clearRedundancy()
{
	qualities data;
	clearRedundancy(blocks,data);
}

void clearRedundancy(block *current,qualities data)
{
	if (current == NULL)
		return;
	if (current->isTag())
	{
		if (current->text=="B>")
		{
			if (data.b || current->deep==NULL || current->deep->text == " ")
			{
				removeBlock(current);
			}else
			{
				data.b = true;
				clearRedundancy(current->deep,data);
				data.b = false;
			}
		}else if (current->text=="EM>")
		{
			if (data.s || current->deep==NULL || current->deep->text == " ")
			{
				removeBlock(current);
			}else if (current->last != NULL && current->last->text == "EM>" && current->last->deep == current)
			{
				removeBlock(current->last);
				removeBlock(current);
			}
			{
				data.em = !data.em;
				clearRedundancy(current->deep,data);
				data.em = !data.em;
			}
		}else if (current->text=="I>")
		{
			if (data.i || current->deep==NULL || current->deep->text == " ")
			{
				removeBlock(current);
			}else
			{
				data.i = true;
				clearRedundancy(current->deep,data);
				data.i = false;
			}
		}else if (current->text=="PL>")
		{
			if ((!(data.b || data.em || data.i || data.s || data.tt) && data.u == 0) || current->deep==NULL || current->deep->text == " ")
			{
				removeBlock(current);
			}else
			{
				qualities newdata;
				newdata.color = data.color;
				newdata.size = data.size;
				clearRedundancy(current->deep,newdata);
			}
		}else if (current->text=="S>")
		{
			if (data.s || current->deep==NULL || current->deep->text == " ")
			{
				removeBlock(current);
			}else
			{
				data.s = true;
				clearRedundancy(current->deep,data);
				data.s = false;
			}
		}else if (current->text=="TT>")
		{
			if (data.tt || current->deep==NULL)
			{
				removeBlock(current);
			}else
			{
				data.tt = true;
				clearRedundancy(current->deep,data);
				data.tt = false;
			}
		}else if (current->text=="U>")
		{
			if (data.u == 3 || current->deep==NULL)
			{
				removeBlock(current);
			}else
			{
				data.u++;
				clearRedundancy(current->deep,data);
				data.u--;
			}
		}else if (current->text=="r>")
		{
			if (data.color == 'r' || current->deep==NULL)
			{
				removeBlock(current);
			}else
			{
				while (current->next != NULL && current->next->isColorTag())
				{
					mergeBlocks(current);
				}
				char colorstore = data.color;
				data.color = 'r';
				clearRedundancy(current->deep,data);
				data.color = colorstore;
			}
		}else if (current->text=="g>")
		{
			if (data.color == 'g' || current->deep==NULL)
			{
				removeBlock(current);
			}else
			{
				while (current->next != NULL && current->next->isColorTag())
				{
					mergeBlocks(current);
				}
				char colorstore = data.color;
				data.color = 'g';
				clearRedundancy(current->deep,data);
				data.color = colorstore;
			}
		}else if (current->text=="b>")
		{
			if (data.color == 'b' || current->deep==NULL)
			{
				removeBlock(current);
			}else
			{
				while (current->next != NULL && current->next->isColorTag())
				{
					mergeBlocks(current);
				}
				char colorstore = data.color;
				data.color = 'b';
				clearRedundancy(current->deep,data);
				data.color = colorstore;
			}
		}else if (current->text=="c>")
		{
			if (data.color == 'c' || current->deep==NULL)
			{
				removeBlock(current);
			}else
			{
				while (current->next != NULL && current->next->isColorTag())
				{
					mergeBlocks(current);
				}
				char colorstore = data.color;
				data.color = 'c';
				clearRedundancy(current->deep,data);
				data.color = colorstore;
			}
		}else if (current->text=="m>")
		{
			if (data.color == 'm' || current->deep==NULL)
			{
				removeBlock(current);
			}else
			{
				while (current->next != NULL && current->next->isColorTag())
				{
					mergeBlocks(current);
				}
				char colorstore = data.color;
				data.color = 'm';
				clearRedundancy(current->deep,data);
				data.color = colorstore;
			}
		}else if (current->text=="y>")
		{
			if (data.color == 'y' || current->deep==NULL)
			{
				removeBlock(current);
			}else
			{
				while (current->next != NULL && current->next->isColorTag())
				{
					mergeBlocks(current);
				}
				char colorstore = data.color;
				data.color = 'y';
				clearRedundancy(current->deep,data);
				data.color = colorstore;
			}
		}else if (current->text=="k>")
		{
			if (data.color == 'k' || current->deep==NULL)
			{
				removeBlock(current);
			}else
			{
				while (current->next != NULL && current->next->isColorTag())
				{
					mergeBlocks(current);
				}
				char colorstore = data.color;
				data.color = 'k';
				clearRedundancy(current->deep,data);
				data.color = colorstore;
			}
		}else if (current->text=="w>")
		{
			if (data.color == 'w' || current->deep==NULL)
			{
				removeBlock(current);
			}else
			{
				while (current->next != NULL && current->next->isColorTag())
				{
					mergeBlocks(current);
				}
				char colorstore = data.color;
				data.color = 'w';
				clearRedundancy(current->deep,data);
				data.color = colorstore;
			}
		}else
		{
			string strStore = "";
			strStore += current->text[0];
			int size = atoi(strStore.c_str());
			if (data.size == size || current->deep==NULL)
			{
				removeBlock(current);
			}else
			{
				int sizestore = data.size;
				data.size = size;
				clearRedundancy(current->deep,data);
				data.size = sizestore;
			}
		}
	}
	clearRedundancy(current->next,data);
}

void removeBlock(block *current)
{
	if (current->last->deep == current)
	{
		current->last->deep = current->deep;
		current->deep->last = current->last;
	}else
	{
		block *store = current->deep;
		if (store == NULL)
		{
			current->last->next = current->next;
			current->next->last = current->last;
			delete current;
			return;
		}
		while (store->next != NULL)
		{
			store = store->next;
		}
		current->last->next = current->deep;
		current->deep->last = current->last;
		store->next = current->next;
		if (current->next != NULL)
			current->next->last = store;
	}
}

void mergeBlocks(block *current)
{
	block *ptr = current->deep;
	while (ptr->next != NULL)
	{
		ptr = ptr->next;
	}
	if (current->text == current->next->text)
	{
		ptr->next = current->next->deep;
		ptr->next->last = ptr;
		current->next = current->next->next;
		if (current->next != NULL)
			current->next->last = current;
	}else
	{
		ptr->next = current->next;
		ptr->next->last = ptr;
		current->next = current->next->next;
		ptr->next->next = NULL;
		if (current->next != NULL)
			current->next->last = current;
	}
}

void writeOutput()
{
	block *current = blocks;
	while (current != NULL)
	{
		if (current->isTag())
		{
			cout << "<" << current->text;
			if (current->deep != NULL)
				writeOutput(current->deep);
			cout << "</" << current->text;
		}else
		{
			cout << current->text;
		}
		current = current->next;
	}
}

void writeOutput(block *current)
{
	while (current != NULL)
	{
		if (current->isTag())
		{
			cout << "<" << current->text;
				writeOutput(current->deep);
			cout << "</" << current->text;
		}else
		{
			cout << current->text;
		}
		current = current->next;
	}
}
		
block::block()
{
		text="";
		next = NULL;
		last = NULL;
		deep = NULL;
}

bool block::isTag()
{
	return (text[text.length()-1] == '>');
}

bool block::isColorTag()
{
	return (text == "r>" ||
					text == "g>" ||
					text == "b>" ||
					text == "c>" ||
					text == "m>" ||
					text == "y>" ||
					text == "k>" ||
					text == "w>");
}

qualities::qualities()
{
	b=false;
	i=false;
	em=false;
	s=false;
	tt=false;
	u=0;
	size=-1;
	color='n';
}